
#include <SPI.h>

#define SCALE_FACTOR 0.000152587890625
#define SPIfrequency (uint32_t) 250000
#define BUSY 33 //3
#define RESET 5 //4
#define START_CONVERSION 5 //5
#define CHIP_SELECT 36 //10
#define TOTAL_RAW_BYTES 16
#define power 16


int bytesToRead = TOTAL_RAW_BYTES;
byte raw[TOTAL_RAW_BYTES];
signed long parsed[8];

void setup() {
  pinMode(BUSY, INPUT);
  pinMode(RESET, OUTPUT);
  pinMode(START_CONVERSION, OUTPUT);
  pinMode(power, OUTPUT);
  // 0pinMode(mode, OUTPUT);
  pinMode(MISO, INPUT);
  
  SPI.begin(); 
  SPI.setDataMode(SPI_MODE0);
  //Initialize Serial
  Serial.begin(9600);

  digitalWrite(power, HIGH);
  //digitalWrite(mode, LOW);
  digitalWrite(START_CONVERSION, HIGH);  
  digitalWrite(CHIP_SELECT, HIGH);
  digitalWrite(RESET, HIGH);
  delay(1);
  digitalWrite(RESET, LOW);
}

void parseRawBytes() {
  int i;

      parsed[0] = (raw[0] << 8) + (raw[1] >> 0);
      parsed[1] = (raw[2] << 8) + (raw[3] >> 0);
      parsed[2] = (raw[4] << 8) + (raw[5] >> 0);
      parsed[3] = (raw[6] << 8) + (raw[7] >> 0);
      parsed[4] = (raw[8] << 8) + (raw[9] >> 0);
      parsed[5] = (raw[10] << 8) + (raw[11] >> 0);
      parsed[6] = (raw[12] << 8) + (raw[13] >> 0);
      parsed[7] = (raw[14] << 8) + (raw[15] >> 0);
for(i=0; i<8; i++) {
    parsed[i] = fixSignBit(parsed[i]);
  }



}

void loop() {
  int i;

  digitalWrite(START_CONVERSION, LOW);
  delayMicroseconds(10);
  digitalWrite(START_CONVERSION, HIGH);

  while (digitalRead(BUSY) == HIGH) {
    // wait for conversion to complete
  }

  SPI.beginTransaction(SPISettings(SPIfrequency, MSBFIRST, SPI_MODE0));
  digitalWrite(CHIP_SELECT, LOW);
  while (bytesToRead > 0) {
    raw[TOTAL_RAW_BYTES - bytesToRead] = SPI.transfer(0x00);
    bytesToRead--;
  }
  digitalWrite(CHIP_SELECT, HIGH);
  bytesToRead = TOTAL_RAW_BYTES;
  
  parseRawBytes();
  
  Serial.print((float)parsed[0] * SCALE_FACTOR, 5);
  Serial.println();
  
  Serial.print("\r\n");
  delay(500);
}



long fixSignBit(long reading) {

      if(reading & 0x8000) { // if reading is < 0 (stored as two's complement)
        return reading | 0xFFFF0000; // set bits 31-16
      } else 
        return reading;
   }
      
