#include <SPI.h>
#include "tdc7200.h"

#define serialbufferSize 50
#define commandDelimeters "|,.- "
#define TDC7200_CS_PIN  15
#define RESOLUTION 16
#define SCALE_FACTOR 0.000152587890625
#define power 16
#define BUSY 33
#define RESET 17
#define START_CONVERSION 18
#define CHIP_SELECT 3
#define LED 13
#define TOTAL_RAW_BYTES RESOLUTION



//real varibles
char inputBuffer[serialbufferSize]   ;
int serialIndex = 0; // keep track of where we are in the buffer
volatile unsigned a;
int num_measure=0;
int bytesToRead = TOTAL_RAW_BYTES;
signed long parsed[8];
/*
byte startpin = 3;
byte stoppin = 4;
byte stop_tx = 22;
*/


// const byte CLOCKOUT = 11; //CLOCK ON MEGA2560
byte config1_rx, config2_rx, int_status, config1_tx, config2_tx, raw[TOTAL_RAW_BYTES];
byte int_mask, ccoh, ccol, clockcoh, clockcol, clockcstopmaskh, clockcstopmaskl;
//float tof1;
float tof1_rx = 0;
float tof1_tx = 0;
// End of real variables

// Setup Code
void setup() 
{  
    //Initialize SPI 
  pinMode(TDC7200_CS_PIN, OUTPUT);
  pinMode(CHIP_SELECT, OUTPUT);
  pinMode(14 , OUTPUT);
  pinMode(MISO, INPUT);
  pinMode(MOSI, OUTPUT);
  
  //pinMode(startpin , OUTPUT);
  //pinMode(stoppin, OUTPUT);
  //pinMode(stop_tx, OUTPUT);
  pinMode(power , OUTPUT);
  pinMode(BUSY, INPUT);
  pinMode(RESET, OUTPUT);
  pinMode(LED, OUTPUT);
  pinMode(START_CONVERSION, OUTPUT);
  pinMode(20, INPUT);
  pinMode(8, INPUT);

  
  SPI.begin(); //chip1Select = 10
  SPI.setDataMode(SPI_MODE0);
    //Initialize Serial
  Serial.begin(9600);
    //Initialize Outputs

  //digitalWrite(3, LOW);
  //pinMode(4, OUTPUT);
  //digitalWrite(4, LOW);
  //pinMode(7, OUTPUT);
  //digitalWrite(7, LOW);
    //Initialize INPUTS

    //STARTUP OF TDC7200
  digitalWrite(power, LOW);
  delay(5); //Sensor needs 300microseconds to startup, 1.5ms recommended
  digitalWrite(power, HIGH);
  delay(5);
  digitalWrite(START_CONVERSION, LOW);
  delay(5);
  digitalWrite(START_CONVERSION, HIGH);
  digitalWrite(RESET, HIGH);
  delay(5);
  digitalWrite(RESET, LOW);
  //digitalWrite(CHIP_SELECT, HIGH);
}

void parseRawBytes() {
  int i;
  parsed[0] = (raw[0] << 8) + (raw[1] >> 0) ;
  parsed[1] = (raw[2] << 8) + (raw[3] >> 0) ;
  parsed[2] = (raw[4] << 8) + (raw[5] >> 0) ;
  parsed[3] = (raw[6] << 8) + (raw[7] >> 0) ;
  parsed[4] = (raw[8] << 8) + (raw[9] >> 0) ;
  parsed[5] = (raw[10] << 8) + (raw[11] >> 0) ;
  parsed[6] = (raw[12] << 8) + (raw[13] >> 0) ;
  parsed[7] = (raw[14] << 8) + (raw[15] >> 0) ;
  
  for(i=0; i<8; i++) {
    parsed[i] = fixSignBit(parsed[i]);
  }
  
}

long fixSignBit(long reading) {
  if(reading & 0x8000) { // if reading is < 0 (stored as two's complement)
        return reading | 0xFFFF0000; // set bits 31-16
      } else {
        return reading;
      }
}

// Function used to start the measuring process
void start_TDC()
{
  int i;
  while(num_measure < 1000){  
    tdc7200 chip1;
  
  
    //WRITE 00000011 INTO CONFIG 1 TO GET READY FOR MEASUREMENT1
    chip1.writeReg(CONFIG1, B00000011);
    chip1.writeReg_TX(CONFIG1, B00000011);
    delayMicroseconds(500);
    //WRITE B01000011 INTO CONFIG2 for FOUR STOPS
              // 000: Single Stop
              // 001: Two Stops
              // 010: Three Stops
              // 011: Four Stops
              // 100: Five Stops
    chip1.writeReg(CONFIG2, B01000000);
    chip1.writeReg_TX(CONFIG2, B01000000);
   delayMicroseconds(500);
    //READ IF CONFIG1/2 CORRECT
    //config1_rx = chip1.readReg8(CONFIG1);
    //config2_rx = chip1.readReg8(CONFIG2);
    
    //delayMicroseconds(500);
    //config1_tx = chip1.readReg8_TX(CONFIG1);
    //config2_tx = chip1.readReg8_TX(CONFIG2);
    

      //WAIT for Trigger Signal == 1
    //while(digitalRead(triggerpin)) {
    //    break;
   // }
        //SEND START

/*
    digitalWrite(startpin, HIGH);
    digitalWrite(startpin, LOW);
    
    digitalWrite(stop_tx, HIGH);
    digitalWrite(stop_tx, LOW);
      
    delayMicroseconds(100);

    digitalWrite(stoppin, HIGH);
    digitalWrite(stoppin, LOW);
      
  */
    
    
    
    //SEND 5 STOPS
    
  
  //READ REGISTERS AND COMPUTE VALUES
    chip1.time1_rx = chip1.readReg24(TIME1);
    chip1.time2_rx = chip1.readReg24(TIME2);
    //chip1.time3_rx = chip1.readReg24(TIME3);
    //chip1.time4_rx = chip1.readReg24(TIME4);
   // chip1.time5_rx = chip1.readReg24(TIME5);
   // chip1.time6_rx = chip1.readReg24(TIME6);
    chip1.clockcount1_rx = chip1.readReg24(CLOCK_COUNT1);
    chip1.clockcount2_rx = chip1.readReg24(CLOCK_COUNT2);
   // chip1.clockcount3_rx = chip1.readReg24(CLOCK_COUNT3);
   // chip1.clockcount4_rx = chip1.readReg24(CLOCK_COUNT4);
   // chip1.clockcount5_rx = chip1.readReg24(CLOCK_COUNT5);
    chip1.cal1_rx = chip1.readReg24(CALIBRATION1);
    chip1.cal2_rx = chip1.readReg24(CALIBRATION2);  
  //END OF READ REGISTERS
  
  
    delayMicroseconds(500);
    
  
  //READ REGISTERS AND COMPUTE VALUES
 
    chip1.time1_tx = chip1.readReg24_TX(TIME1);
    chip1.time2_tx = chip1.readReg24_TX(TIME2);
    //chip1.time3_tx = chip1.readReg24_TX(TIME3);
    //chip1.time4_tx = chip1.readReg24_TX(TIME4);
    //chip1.time5_tx = chip1.readReg24_TX(TIME5);
    //chip1.time6_tx = chip1.readReg24_TX(TIME6);
    chip1.clockcount1_tx = chip1.readReg24_TX(CLOCK_COUNT1);
    chip1.clockcount2_tx = chip1.readReg24_TX(CLOCK_COUNT2);
    //chip1.clockcount3_tx = chip1.readReg24_TX(CLOCK_COUNT3);
    //chip1.clockcount4_tx = chip1.readReg24_TX(CLOCK_COUNT4);
    //chip1.clockcount5_tx = chip1.readReg24_TX(CLOCK_COUNT5);
    chip1.cal1_tx = chip1.readReg24_TX(CALIBRATION1);
    chip1.cal2_tx = chip1.readReg24_TX(CALIBRATION2);
   
 
    delayMicroseconds(500);
  //END OF READ REGISTERS
    tof1_rx = chip1.getTOF_rx(chip1.time1_rx , chip1.time2_rx ,chip1.clockcount1_rx, chip1.cal1_rx , chip1.cal2_rx);
  
    tof1_tx = chip1.getTOF_tx(chip1.time1_tx , chip1.time2_tx ,chip1.clockcount1_tx, chip1.cal1_tx , chip1.cal2_tx);

   // Serial.print("* TOF1 = ");
    Serial.print(tof1_rx*1E6,5); //Serial.println(" us*");
    Serial.print(",");
  
  //  Serial.print("* TOF1 TX = ");
    Serial.print(tof1_tx*1E6,5);// Serial.println(" us*");

    Serial.println();
  
    num_measure++;

   /* if (num_measure==1000)
    {
      //Serial.println("*********************");
      //Serial.println();
     num_measure=0;
      delay(1);
    }
    */
  }

  // AD7606
  if (num_measure == 1000){
   while (digitalRead(BUSY) == HIGH) {
    // wait for conversion to complete
  }
  SPI.beginTransaction(SPISettings(2500000, MSBFIRST, SPI_MODE0));
  digitalWrite(CHIP_SELECT, LOW);
  while (bytesToRead > 0) {
    raw[TOTAL_RAW_BYTES - bytesToRead] = SPI.transfer(0x00);
    bytesToRead--;
  }
  digitalWrite(CHIP_SELECT, HIGH);
  SPI.endTransaction();
  bytesToRead = TOTAL_RAW_BYTES;
  
  parseRawBytes();

  //Serial.write(raw, 16);

  for(i=0; i<8; i++) {
    Serial.print((float)parsed[i] * SCALE_FACTOR, 5);
    Serial.print(",");
  }
  Serial.print("\r\n");
  delay(500);
  num_measure=0;
  
  }


}


// Loop 
void loop() 
{  
    
   // see if there is a command come in on the serial port and if so call the command processor
    if (CheckSerial()) DoCommand(inputBuffer);
}

// Functions to interact with the board
boolean CheckSerial()
{
  boolean lineFound = false;
  // if there's any serial available, read it:
  while (Serial.available() > 0) {
    //Read a character as it comes in:
    //currently this will throw away anything after the buffer is full or the \n is detected
    char charBuffer = Serial.read();
    if (charBuffer == '\n') {
      inputBuffer[serialIndex] = 0; // terminate the string
      lineFound = (serialIndex > 0); // only good if we sent more than an empty line
      serialIndex = 0; // reset for next line of data
    }
    else if (charBuffer == '\r') {
      // Just ignore the Carrage return, were only interested in new line
    }
    else if (serialIndex < serialbufferSize && lineFound == false) {
      /*Place the character in the string buffer:*/
      inputBuffer[serialIndex++] = charBuffer; // auto increment index
    }
  }// End of While
  return lineFound;
}// End of CheckSerial()

// Function to receive commands through the serial interface
boolean DoCommand(char * commandBuffer)
{
  Serial.println("Command");
  char* Command; // Command Parameter
  char* Parameter; // Additional Parameter


  // Get the command from the input string
  Command = strtok(commandBuffer, commandDelimeters); // get the command
  Parameter = strtok(NULL, commandDelimeters); // get the parameter if any
  //if there are more than one parameter they will be ignored for now
 if (strcmp(Command, "start") == 0) { start_TDC(); num_measure=0;}
 
 else {  Serial.print("Error "); Serial.println(commandBuffer); }
 return true;




}
