#include <SPI.h>
#include "tdc7200.h"

#define serialbufferSize 50
#define commandDelimeters "|,.- "
#define TDC7200_CS_PIN  15


//real varibles
char inputBuffer[serialbufferSize]   ;
int serialIndex = 0; // keep track of where we are in the buffer
int num_measure=0;
byte power = 16;
byte config1_rx, config2_rx, int_status, config1_tx, config2_tx;
byte int_mask, ccoh, ccol, clockcoh, clockcol, clockcstopmaskh, clockcstopmaskl;
float tof_rx = 0;
float tof_tx = 0;
// End of real variables

// Setup Code
void setup() 
{  
    //Initialize SPI 
  pinMode(TDC7200_CS_PIN, OUTPUT);
  pinMode(14 , OUTPUT);
  pinMode(MISO, INPUT);
  pinMode(MOSI, OUTPUT);
  pinMode(power , OUTPUT);

  
  SPI.begin(); 
    //Initialize Serial
  Serial.begin(9600);
    //Initialize Outputs
  digitalWrite(power, LOW);
  delay(5); //Sensor needs 300microseconds to startup, 1.5ms recommended
  digitalWrite(power, HIGH);
  delay(5);
}
// Function used to start the measuring process
void start_TDC()
{

  while(num_measure < 1000){  
    tdc7200 chip1;
  
  
    //WRITE 00000011 INTO CONFIG 1 TO GET READY FOR MEASUREMENT1
    chip1.writeReg(CONFIG1, B00000001);
    chip1.writeReg_TX(CONFIG1, B00000001);
    delayMicroseconds(100);
    //WRITE B01000011 INTO CONFIG2 for FOUR STOPS
              // 000: Single Stop
              // 001: Two Stops
              // 010: Three Stops
              // 011: Four Stops
              // 100: Five Stops
    chip1.writeReg(CONFIG2, B01000100);
    chip1.writeReg_TX(CONFIG2, B01000100);
   delayMicroseconds(100);
    
    
    //SEND 5 STOPS
    
  
  //READ REGISTERS AND COMPUTE VALUES
    chip1.time1_rx = chip1.readReg24(TIME1);
    chip1.time1_tx = chip1.readReg24_TX(TIME1);
    chip1.time2_rx = chip1.readReg24(TIME2);
    chip1.time2_tx = chip1.readReg24_TX(TIME2);
    chip1.time3_rx = chip1.readReg24(TIME3);
    chip1.time4_rx = chip1.readReg24(TIME4);
    chip1.time5_rx = chip1.readReg24(TIME5);
    chip1.time6_rx = chip1.readReg24(TIME6);
    chip1.clockcount1_rx = chip1.readReg24(CLOCK_COUNT1);
    chip1.clockcount1_tx = chip1.readReg24_TX(CLOCK_COUNT1);
    chip1.clockcount2_rx = chip1.readReg24(CLOCK_COUNT2);
    chip1.clockcount2_tx = chip1.readReg24_TX(CLOCK_COUNT2);
    chip1.clockcount3_rx = chip1.readReg24(CLOCK_COUNT3);
    chip1.clockcount4_rx = chip1.readReg24(CLOCK_COUNT4);
    chip1.clockcount5_rx = chip1.readReg24(CLOCK_COUNT5);
    chip1.cal1_rx = chip1.readReg24(CALIBRATION1);
    chip1.cal1_tx = chip1.readReg24_TX(CALIBRATION1);
    chip1.cal2_rx = chip1.readReg24(CALIBRATION2); 
    chip1.cal2_tx = chip1.readReg24_TX(CALIBRATION2); 
  //END OF READ REGISTERS
  
  
    
  
  //READ REGISTERS AND COMPUTE VALUES
 
    
    
    chip1.time3_tx = chip1.readReg24_TX(TIME3);
    chip1.time4_tx = chip1.readReg24_TX(TIME4);
    chip1.time5_tx = chip1.readReg24_TX(TIME5);
    chip1.time6_tx = chip1.readReg24_TX(TIME6);
    chip1.clockcount1_tx = chip1.readReg24_TX(CLOCK_COUNT1);
    chip1.clockcount3_tx = chip1.readReg24_TX(CLOCK_COUNT3);
    chip1.clockcount4_tx = chip1.readReg24_TX(CLOCK_COUNT4);
    chip1.clockcount5_tx = chip1.readReg24_TX(CLOCK_COUNT5);


  chip1.tof1 = chip1.getTOF_rx(chip1.time1_rx , chip1.time2_rx ,chip1.clockcount1_rx, chip1.cal1_rx , chip1.cal2_rx);
  chip1.tof2 = chip1.getTOF_rx(chip1.time1_rx , chip1.time3_rx ,chip1.clockcount2_rx, chip1.cal1_rx , chip1.cal2_rx);
  chip1.tof3 = chip1.getTOF_rx(chip1.time1_rx, chip1.time4_rx, chip1.clockcount3_rx, chip1.cal1_rx, chip1.cal2_rx);
  chip1.tof4 = chip1.getTOF_rx(chip1.time1_rx, chip1.time5_rx, chip1.clockcount4_rx, chip1.cal1_rx, chip1.cal2_rx);
  chip1.tof5 = chip1.getTOF_rx(chip1.time1_rx, chip1.time6_rx, chip1.clockcount5_rx, chip1.cal1_rx, chip1.cal2_rx);

  
  tof_rx = (chip1.tof1+chip1.tof2+chip1.tof3+chip1.tof4+chip1.tof5)/5;


  chip1.tof1 = chip1.getTOF_tx(chip1.time1_tx , chip1.time2_tx ,chip1.clockcount1_tx, chip1.cal1_tx , chip1.cal2_tx);
  chip1.tof2 = chip1.getTOF_tx(chip1.time1_tx , chip1.time3_tx ,chip1.clockcount2_tx, chip1.cal1_tx , chip1.cal2_tx);
  chip1.tof3 = chip1.getTOF_tx(chip1.time1_tx, chip1.time4_tx, chip1.clockcount3_tx, chip1.cal1_tx, chip1.cal2_tx);
  chip1.tof4 = chip1.getTOF_tx(chip1.time1_tx, chip1.time5_tx, chip1.clockcount4_tx, chip1.cal1_tx, chip1.cal2_tx);
  chip1.tof5 = chip1.getTOF_tx(chip1.time1_tx, chip1.time6_tx, chip1.clockcount5_tx, chip1.cal1_tx, chip1.cal2_tx);

  
  tof_tx = (chip1.tof1+chip1.tof2+chip1.tof3+chip1.tof4+chip1.tof5)/5;
    
   
 
  
  //END OF READ REGISTERS
  /*


  Serial.println();
  Serial.print(chip1.tof1*1E6,8); 
  Serial.print(",");
  Serial.print(chip1.tof2*1E6,8); 
  Serial.print(",");
  Serial.print(chip1.tof3*1E6,8);
  Serial.print(",");
  Serial.print(chip1.tof4*1E6,8); 
  Serial.print(",");
  Serial.print(chip1.tof5*1E6,8); 

  Serial.println();
  */
    /*
    int_status = chip1.readReg8_TX(INT_STATUS);
    Serial.print("INT_STATUS = "); Serial.println(int_status,BIN);
    int_mask = chip1.readReg8(INT_MASK);
    ccoh = chip1.readReg8(COARSE_CNTR_OVF_H);
    ccol = chip1.readReg8(COARSE_CNTR_OVF_L);
    clockcoh = chip1.readReg8(CLOCK_CNTR_OVF_H);
    clockcol = chip1.readReg8(CLOCK_CNTR_OVF_L);
    clockcstopmaskh = chip1.readReg8(CLOCK_CNTR_STOP_MASK_H);
    clockcstopmaskl = chip1.readReg8(CLOCK_CNTR_STOP_MASK_L);
  
    Serial.print("INT_MASK = "); Serial.println(int_mask,BIN);
    Serial.print("COARSE_CNTR_OVF_H = "); Serial.println(ccoh,BIN);
    Serial.print("COARSE_CNTR_OVF_L = "); Serial.println(ccol,BIN);
    Serial.print("CLOCK_CNTR_OVF_H = "); Serial.println(clockcoh,BIN);
    Serial.print("COARSE_CNTR_OVF_L = "); Serial.println(clockcol,BIN);
    Serial.print("COARSE_CNTR_OVF_L = "); Serial.println(clockcstopmaskh,BIN);
    Serial.print("COARSE_CNTR_OVF_L = "); Serial.println(clockcstopmaskl,BIN);
  
    
    Serial.println();
  
    */
    //TESTPRINT CONFIG1/2
    
    //Serial.print("CONFIG1_RX = "); Serial.println(config1_rx, BIN);
    //Serial.print(",");
    //Serial.print("CONFIG2_RX = "); Serial.println(config2_rx, BIN);
    //Serial.print(",");
    //Serial.print("CONFIG1_TX = "); Serial.println(config1_tx, BIN);
    //Serial.print("CONFIG2_TX = "); Serial.println(config2_tx, BIN);
   // Serial.print(",");
    //Serial.print("TIME1 = "); Serial.println(chip1.readReg24_TX(TIME1), BIN);
   // Serial.print(",");
    //Serial.println();
  //  Serial.print("  ****************");
   // Serial.println();
   // Serial.print("* TOF1 = ");
    Serial.print(tof_rx*1E6,8); //Serial.println(" us*");
    Serial.print(",");
  
  //  Serial.print("* TOF1 TX = ");
    Serial.print(tof_tx*1E6,8);// Serial.println(" us*");
    //Serial.print(",");
    /*
    Serial.print("* TOF2 = ");
    Serial.print(chip1.tof2,8); Serial.println(" *");
    Serial.print("* TOF3 = ");
    Serial.print(chip1.tof3,8); Serial.println(" *");
    Serial.print("* TOF4 = ");
    Serial.print(chip1.tof4,8); Serial.println(" *");
    Serial.print("* TOF5 = ");
    Serial.print(chip1.tof5,8); Serial.println(" *"); 
    Serial.print("  ****************");
    */
    Serial.println();
  
    num_measure++;

    if (num_measure==1000)
    {
     num_measure=0;
      delay(1);
    }
  }



}


// Loop 
void loop() 
{  
    
   // see if there is a command come in on the serial port and if so call the command processor
    if (CheckSerial()) DoCommand(inputBuffer);
}

// Functions to interact with the board
boolean CheckSerial()
{
  boolean lineFound = false;
  // if there's any serial available, read it:
  while (Serial.available() > 0) {
    //Read a character as it comes in:
    
    char charBuffer = Serial.read();
    if (charBuffer == '\n') {
      inputBuffer[serialIndex] = 0; // terminate the string
      lineFound = (serialIndex > 0); // 
      serialIndex = 0; // reset for next line of data
    }
    else if (charBuffer == '\r') {
      
    }
    else if (serialIndex < serialbufferSize && lineFound == false) {
      /*Place the character in the string buffer:*/
      inputBuffer[serialIndex++] = charBuffer; // auto increment index
    }
  }// End of While
  return lineFound;
}// End of CheckSerial()

// Function to receive commands through the serial interface
boolean DoCommand(char * commandBuffer)
{
  Serial.println("Command");
  char* Command; // Command Parameter
  char* Parameter; // Additional Parameter


  // Get the command from the input string
  Command = strtok(commandBuffer, commandDelimeters); // get the command
  Parameter = strtok(NULL, commandDelimeters); // get the parameter if any
  //if there are more than one parameter they will be ignored for now
 if (strcmp(Command, "start") == 0) { start_TDC(); num_measure=0;}
 
 else {  Serial.print("Error "); Serial.println(commandBuffer); }
 return true;




}
/*
  //READ/WRITE NEW_MEASUREMENT into Interrupt
  int_status = chip1.readReg8(INT_STATUS);
  int_mask = chip1.readReg8(INT_MASK);
  ccoh = chip1.readReg8(COARSE_CNTR_OVF_H);
  ccol = chip1.readReg8(COARSE_CNTR_OVF_L);
  clockcoh = chip1.readReg8(CLOCK_CNTR_OVF_H);
  clockcol = chip1.readReg8(CLOCK_CNTR_OVF_L);
  clockcstopmaskh = chip1.readReg8(CLOCK_CNTR_STOP_MASK_H);
  clockcstopmaskl = chip1.readReg8(CLOCK_CNTR_STOP_MASK_L);
  
  Serial.print("INT_STATUS = "); Serial.println(int_status,BIN);
  Serial.print("INT_MASK = "); Serial.println(int_mask,BIN);
  Serial.print("COARSE_CNTR_OVF_H = "); Serial.println(ccoh,BIN);
  Serial.print("COARSE_CNTR_OVF_L = "); Serial.println(ccol,BIN);
  Serial.print("CLOCK_CNTR_OVF_H = "); Serial.println(clockcoh,BIN);
  Serial.print("COARSE_CNTR_OVF_L = "); Serial.println(clockcol,BIN);
  Serial.print("COARSE_CNTR_OVF_L = "); Serial.println(clockcstopmaskh,BIN);
  Serial.print("COARSE_CNTR_OVF_L = "); Serial.println(clockcstopmaskl,BIN);

  
  Serial.println();


/*
  //PRINTS FOR DEBUG
  Serial.print("TIME1 = "); Serial.println(chip1.time1);
  Serial.print("CLOCK_COUNT1 = "); Serial.println(chip1.clockcount1);
  Serial.print("TIME2 = "); Serial.println(chip1.time2);
  Serial.print("CLOCK_COUNT2 = "); Serial.println(chip1.clockcount2);
  Serial.print("TIME3 = "); Serial.println(chip1.time3);
  Serial.print("CLOCK_COUNT3 = "); Serial.println(chip1.clockcount3);
  Serial.print("TIME4 = "); Serial.println(chip1.time4);
  Serial.print("CLOCK_COUNT4 = "); Serial.println(chip1.clockcount4);
  Serial.print("TIME5 = "); Serial.println(chip1.time5);
  //Serial.print("CLOCK_COUNT5 = "); Serial.println(chip1.clockcount5);
  //Serial.print("TIME6 = "); Serial.println(chip1.time6);
  Serial.print("CALIBRATION1 = "); Serial.println(chip1.cal1);
  Serial.print("CALIBRATION2 = "); Serial.println(chip1.cal2);
*/
